# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.alert_value_widget_definition_type import AlertValueWidgetDefinitionType
    from datadog_api_client.v1.model.widget_text_align import WidgetTextAlign

    globals()["AlertValueWidgetDefinitionType"] = AlertValueWidgetDefinitionType
    globals()["WidgetTextAlign"] = WidgetTextAlign


class AlertValueWidgetDefinition(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "alert_id": (str,),
            "precision": (int,),
            "text_align": (WidgetTextAlign,),
            "title": (str,),
            "title_align": (WidgetTextAlign,),
            "title_size": (str,),
            "type": (AlertValueWidgetDefinitionType,),
            "unit": (str,),
        }

    attribute_map = {
        "alert_id": "alert_id",
        "type": "type",
        "precision": "precision",
        "text_align": "text_align",
        "title": "title",
        "title_align": "title_align",
        "title_size": "title_size",
        "unit": "unit",
    }

    read_only_vars = {}

    def __init__(self, alert_id, type, *args, **kwargs):
        """AlertValueWidgetDefinition - a model defined in OpenAPI

        Args:
            alert_id (str): ID of the alert to use in the widget.
            type (AlertValueWidgetDefinitionType):

        Keyword Args:
            precision (int): [optional] Number of decimal to show. If not defined, will use the raw value.
            text_align (WidgetTextAlign): [optional]
            title (str): [optional] Title of the widget.
            title_align (WidgetTextAlign): [optional]
            title_size (str): [optional] Size of value in the widget.
            unit (str): [optional] Unit to display with the value.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.alert_id = alert_id
        self.type = type

    @classmethod
    def _from_openapi_data(cls, alert_id, type, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(AlertValueWidgetDefinition, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.alert_id = alert_id
        self.type = type
        return self
