# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.table_widget_cell_display_mode import TableWidgetCellDisplayMode
    from datadog_api_client.v1.model.widget_sort import WidgetSort

    globals()["TableWidgetCellDisplayMode"] = TableWidgetCellDisplayMode
    globals()["WidgetSort"] = WidgetSort


class ApmStatsQueryColumnType(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "alias": (str,),
            "cell_display_mode": (TableWidgetCellDisplayMode,),
            "name": (str,),
            "order": (WidgetSort,),
        }

    attribute_map = {
        "name": "name",
        "alias": "alias",
        "cell_display_mode": "cell_display_mode",
        "order": "order",
    }

    read_only_vars = {}

    def __init__(self, name, *args, **kwargs):
        """ApmStatsQueryColumnType - a model defined in OpenAPI

        Args:
            name (str): Column name.

        Keyword Args:
            alias (str): [optional] A user-assigned alias for the column.
            cell_display_mode (TableWidgetCellDisplayMode): [optional]
            order (WidgetSort): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.name = name

    @classmethod
    def _from_openapi_data(cls, name, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(ApmStatsQueryColumnType, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.name = name
        return self
