# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.check_status_widget_definition_type import CheckStatusWidgetDefinitionType
    from datadog_api_client.v1.model.widget_grouping import WidgetGrouping
    from datadog_api_client.v1.model.widget_text_align import WidgetTextAlign
    from datadog_api_client.v1.model.widget_time import WidgetTime

    globals()["CheckStatusWidgetDefinitionType"] = CheckStatusWidgetDefinitionType
    globals()["WidgetGrouping"] = WidgetGrouping
    globals()["WidgetTextAlign"] = WidgetTextAlign
    globals()["WidgetTime"] = WidgetTime


class CheckStatusWidgetDefinition(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "check": (str,),
            "group": (str,),
            "group_by": ([str],),
            "grouping": (WidgetGrouping,),
            "tags": ([str],),
            "time": (WidgetTime,),
            "title": (str,),
            "title_align": (WidgetTextAlign,),
            "title_size": (str,),
            "type": (CheckStatusWidgetDefinitionType,),
        }

    attribute_map = {
        "check": "check",
        "grouping": "grouping",
        "type": "type",
        "group": "group",
        "group_by": "group_by",
        "tags": "tags",
        "time": "time",
        "title": "title",
        "title_align": "title_align",
        "title_size": "title_size",
    }

    read_only_vars = {}

    def __init__(self, check, grouping, type, *args, **kwargs):
        """CheckStatusWidgetDefinition - a model defined in OpenAPI

        Args:
            check (str): Name of the check to use in the widget.
            grouping (WidgetGrouping):
            type (CheckStatusWidgetDefinitionType):

        Keyword Args:
            group (str): [optional] Group reporting a single check.
            group_by ([str]): [optional] List of tag prefixes to group by in the case of a cluster check.
            tags ([str]): [optional] List of tags used to filter the groups reporting a cluster check.
            time (WidgetTime): [optional]
            title (str): [optional] Title of the widget.
            title_align (WidgetTextAlign): [optional]
            title_size (str): [optional] Size of the title.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.check = check
        self.grouping = grouping
        self.type = type

    @classmethod
    def _from_openapi_data(cls, check, grouping, type, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(CheckStatusWidgetDefinition, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.check = check
        self.grouping = grouping
        self.type = type
        return self
