# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    none_type,
)


class Creator(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "email": (str,),
            "handle": (str,),
            "name": (
                str,
                none_type,
            ),
        }

    attribute_map = {
        "email": "email",
        "handle": "handle",
        "name": "name",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """Creator - a model defined in OpenAPI

        Keyword Args:
            email (str): [optional] Email of the creator.
            handle (str): [optional] Handle of the creator.
            name (str, none_type): [optional] Name of the creator.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(Creator, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
