# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    datetime,
    none_type,
)


def lazy_import():
    from datadog_api_client.v1.model.dashboard_layout_type import DashboardLayoutType

    globals()["DashboardLayoutType"] = DashboardLayoutType


class DashboardSummaryDefinition(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "author_handle": (str,),
            "created_at": (datetime,),
            "description": (
                str,
                none_type,
            ),
            "id": (str,),
            "is_read_only": (bool,),
            "layout_type": (DashboardLayoutType,),
            "modified_at": (datetime,),
            "title": (str,),
            "url": (str,),
        }

    attribute_map = {
        "author_handle": "author_handle",
        "created_at": "created_at",
        "description": "description",
        "id": "id",
        "is_read_only": "is_read_only",
        "layout_type": "layout_type",
        "modified_at": "modified_at",
        "title": "title",
        "url": "url",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """DashboardSummaryDefinition - a model defined in OpenAPI

        Keyword Args:
            author_handle (str): [optional] Identifier of the dashboard author.
            created_at (datetime): [optional] Creation date of the dashboard.
            description (str, none_type): [optional] Description of the dashboard.
            id (str): [optional] Dashboard identifier.
            is_read_only (bool): [optional] Whether this dashboard is read-only. If True, only the author and admins can make changes to it.
            layout_type (DashboardLayoutType): [optional]
            modified_at (datetime): [optional] Modification date of the dashboard.
            title (str): [optional] Title of the dashboard.
            url (str): [optional] URL of the dashboard.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(DashboardSummaryDefinition, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
