# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class GCPAccount(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "auth_provider_x509_cert_url": (str,),
            "auth_uri": (str,),
            "automute": (bool,),
            "client_email": (str,),
            "client_id": (str,),
            "client_x509_cert_url": (str,),
            "errors": ([str],),
            "host_filters": (str,),
            "private_key": (str,),
            "private_key_id": (str,),
            "project_id": (str,),
            "token_uri": (str,),
            "type": (str,),
        }

    attribute_map = {
        "auth_provider_x509_cert_url": "auth_provider_x509_cert_url",
        "auth_uri": "auth_uri",
        "automute": "automute",
        "client_email": "client_email",
        "client_id": "client_id",
        "client_x509_cert_url": "client_x509_cert_url",
        "errors": "errors",
        "host_filters": "host_filters",
        "private_key": "private_key",
        "private_key_id": "private_key_id",
        "project_id": "project_id",
        "token_uri": "token_uri",
        "type": "type",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """GCPAccount - a model defined in OpenAPI

        Keyword Args:
            auth_provider_x509_cert_url (str): [optional] Should be `https://www.googleapis.com/oauth2/v1/certs`.
            auth_uri (str): [optional] Should be `https://accounts.google.com/o/oauth2/auth`.
            automute (bool): [optional] Silence monitors for expected GCE instance shutdowns.
            client_email (str): [optional] Your email found in your JSON service account key.
            client_id (str): [optional] Your ID found in your JSON service account key.
            client_x509_cert_url (str): [optional] Should be `https://www.googleapis.com/robot/v1/metadata/x509/<CLIENT_EMAIL>` where `<CLIENT_EMAIL>` is the email found in your JSON service account key.
            errors ([str]): [optional] An array of errors.
            host_filters (str): [optional] Limit the GCE instances that are pulled into Datadog by using tags. Only hosts that match one of the defined tags are imported into Datadog.
            private_key (str): [optional] Your private key name found in your JSON service account key.
            private_key_id (str): [optional] Your private key ID found in your JSON service account key.
            project_id (str): [optional] Your Google Cloud project ID found in your JSON service account key.
            token_uri (str): [optional] Should be `https://accounts.google.com/o/oauth2/token`.
            type (str): [optional] The value for service_account found in your JSON service account key.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(GCPAccount, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
