# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.geomap_widget_definition_style import GeomapWidgetDefinitionStyle
    from datadog_api_client.v1.model.geomap_widget_definition_type import GeomapWidgetDefinitionType
    from datadog_api_client.v1.model.geomap_widget_definition_view import GeomapWidgetDefinitionView
    from datadog_api_client.v1.model.geomap_widget_request import GeomapWidgetRequest
    from datadog_api_client.v1.model.widget_custom_link import WidgetCustomLink
    from datadog_api_client.v1.model.widget_text_align import WidgetTextAlign
    from datadog_api_client.v1.model.widget_time import WidgetTime

    globals()["GeomapWidgetDefinitionStyle"] = GeomapWidgetDefinitionStyle
    globals()["GeomapWidgetDefinitionType"] = GeomapWidgetDefinitionType
    globals()["GeomapWidgetDefinitionView"] = GeomapWidgetDefinitionView
    globals()["GeomapWidgetRequest"] = GeomapWidgetRequest
    globals()["WidgetCustomLink"] = WidgetCustomLink
    globals()["WidgetTextAlign"] = WidgetTextAlign
    globals()["WidgetTime"] = WidgetTime


class GeomapWidgetDefinition(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {
        "requests": {
            "max_items": 1,
            "min_items": 1,
        },
    }

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "custom_links": ([WidgetCustomLink],),
            "requests": ([GeomapWidgetRequest],),
            "style": (GeomapWidgetDefinitionStyle,),
            "time": (WidgetTime,),
            "title": (str,),
            "title_align": (WidgetTextAlign,),
            "title_size": (str,),
            "type": (GeomapWidgetDefinitionType,),
            "view": (GeomapWidgetDefinitionView,),
        }

    attribute_map = {
        "requests": "requests",
        "style": "style",
        "type": "type",
        "view": "view",
        "custom_links": "custom_links",
        "time": "time",
        "title": "title",
        "title_align": "title_align",
        "title_size": "title_size",
    }

    read_only_vars = {}

    def __init__(self, requests, style, type, view, *args, **kwargs):
        """GeomapWidgetDefinition - a model defined in OpenAPI

        Args:
            requests ([GeomapWidgetRequest]): Array of one request object to display in the widget. The request must contain a `group-by` tag whose value is a country ISO code.  See the [Request JSON schema documentation](https://docs.datadoghq.com/dashboards/graphing_json/request_json) for information about building the `REQUEST_SCHEMA`.
            style (GeomapWidgetDefinitionStyle):
            type (GeomapWidgetDefinitionType):
            view (GeomapWidgetDefinitionView):

        Keyword Args:
            custom_links ([WidgetCustomLink]): [optional] A list of custom links.
            time (WidgetTime): [optional]
            title (str): [optional] The title of your widget.
            title_align (WidgetTextAlign): [optional]
            title_size (str): [optional] The size of the title.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.requests = requests
        self.style = style
        self.type = type
        self.view = view

    @classmethod
    def _from_openapi_data(cls, requests, style, type, view, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(GeomapWidgetDefinition, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.requests = requests
        self.style = style
        self.type = type
        self.view = view
        return self
