# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.group_widget_definition_type import GroupWidgetDefinitionType
    from datadog_api_client.v1.model.widget import Widget
    from datadog_api_client.v1.model.widget_layout_type import WidgetLayoutType
    from datadog_api_client.v1.model.widget_text_align import WidgetTextAlign

    globals()["GroupWidgetDefinitionType"] = GroupWidgetDefinitionType
    globals()["Widget"] = Widget
    globals()["WidgetLayoutType"] = WidgetLayoutType
    globals()["WidgetTextAlign"] = WidgetTextAlign


class GroupWidgetDefinition(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "background_color": (str,),
            "banner_img": (str,),
            "layout_type": (WidgetLayoutType,),
            "show_title": (bool,),
            "title": (str,),
            "title_align": (WidgetTextAlign,),
            "type": (GroupWidgetDefinitionType,),
            "widgets": ([Widget],),
        }

    attribute_map = {
        "layout_type": "layout_type",
        "type": "type",
        "widgets": "widgets",
        "background_color": "background_color",
        "banner_img": "banner_img",
        "show_title": "show_title",
        "title": "title",
        "title_align": "title_align",
    }

    read_only_vars = {}

    def __init__(self, layout_type, type, widgets, *args, **kwargs):
        """GroupWidgetDefinition - a model defined in OpenAPI

        Args:
            layout_type (WidgetLayoutType):
            type (GroupWidgetDefinitionType):
            widgets ([Widget]): List of widget groups.

        Keyword Args:
            background_color (str): [optional] Background color of the group title.
            banner_img (str): [optional] URL of image to display as a banner for the group.
            show_title (bool): [optional] Whether to show the title or not. If omitted the server will use the default value of True.
            title (str): [optional] Title of the widget.
            title_align (WidgetTextAlign): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.layout_type = layout_type
        self.type = type
        self.widgets = widgets

    @classmethod
    def _from_openapi_data(cls, layout_type, type, widgets, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(GroupWidgetDefinition, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.layout_type = layout_type
        self.type = type
        self.widgets = widgets
        return self
