# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class HostMapWidgetDefinitionStyle(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "fill_max": (str,),
            "fill_min": (str,),
            "palette": (str,),
            "palette_flip": (bool,),
        }

    attribute_map = {
        "fill_max": "fill_max",
        "fill_min": "fill_min",
        "palette": "palette",
        "palette_flip": "palette_flip",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """HostMapWidgetDefinitionStyle - a model defined in OpenAPI

        Keyword Args:
            fill_max (str): [optional] Max value to use to color the map.
            fill_min (str): [optional] Min value to use to color the map.
            palette (str): [optional] Color palette to apply to the widget.
            palette_flip (bool): [optional] Whether to flip the palette tones.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(HostMapWidgetDefinitionStyle, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
