# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.agent_check import AgentCheck
    from datadog_api_client.v1.model.host_meta_install_method import HostMetaInstallMethod

    globals()["AgentCheck"] = AgentCheck
    globals()["HostMetaInstallMethod"] = HostMetaInstallMethod


class HostMeta(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "agent_checks": ([AgentCheck],),
            "agent_version": (str,),
            "cpu_cores": (int,),
            "fbsd_v": ([str],),
            "gohai": (str,),
            "install_method": (HostMetaInstallMethod,),
            "mac_v": ([str],),
            "machine": (str,),
            "nix_v": ([str],),
            "platform": (str,),
            "processor": (str,),
            "python_v": (str,),
            "socket_fqdn": (str,),
            "socket_hostname": (str,),
            "win_v": ([str],),
        }

    attribute_map = {
        "agent_checks": "agent_checks",
        "agent_version": "agent_version",
        "cpu_cores": "cpuCores",
        "fbsd_v": "fbsdV",
        "gohai": "gohai",
        "install_method": "install_method",
        "mac_v": "macV",
        "machine": "machine",
        "nix_v": "nixV",
        "platform": "platform",
        "processor": "processor",
        "python_v": "pythonV",
        "socket_fqdn": "socket-fqdn",
        "socket_hostname": "socket-hostname",
        "win_v": "winV",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """HostMeta - a model defined in OpenAPI

        Keyword Args:
            agent_checks ([AgentCheck]): [optional] A list of Agent checks running on the host.
            agent_version (str): [optional] The Datadog Agent version.
            cpu_cores (int): [optional] The number of cores.
            fbsd_v ([str]): [optional] An array of Mac versions.
            gohai (str): [optional] JSON string containing system information.
            install_method (HostMetaInstallMethod): [optional]
            mac_v ([str]): [optional] An array of Mac versions.
            machine (str): [optional] The machine architecture.
            nix_v ([str]): [optional] Array of Unix versions.
            platform (str): [optional] The OS platform.
            processor (str): [optional] The processor.
            python_v (str): [optional] The Python version.
            socket_fqdn (str): [optional] The socket fqdn.
            socket_hostname (str): [optional] The socket hostname.
            win_v ([str]): [optional] An array of Windows versions.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(HostMeta, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
