# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class HostMetrics(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "cpu": (float,),
            "iowait": (float,),
            "load": (float,),
        }

    attribute_map = {
        "cpu": "cpu",
        "iowait": "iowait",
        "load": "load",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """HostMetrics - a model defined in OpenAPI

        Keyword Args:
            cpu (float): [optional] The percent of CPU used (everything but idle).
            iowait (float): [optional] The percent of CPU spent waiting on the IO (not reported for all platforms).
            load (float): [optional] The system load over the last 15 minutes.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(HostMetrics, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
