# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class HostTotals(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "total_active": (int,),
            "total_up": (int,),
        }

    attribute_map = {
        "total_active": "total_active",
        "total_up": "total_up",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """HostTotals - a model defined in OpenAPI

        Keyword Args:
            total_active (int): [optional] Total number of active host (UP and ???) reporting to Datadog.
            total_up (int): [optional] Number of host that are UP and reporting to Datadog.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(HostTotals, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
