# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    datetime,
)


def lazy_import():
    from datadog_api_client.v1.model.hourly_usage_attribution_usage_type import HourlyUsageAttributionUsageType
    from datadog_api_client.v1.model.usage_attribution_tag_names import UsageAttributionTagNames

    globals()["HourlyUsageAttributionUsageType"] = HourlyUsageAttributionUsageType
    globals()["UsageAttributionTagNames"] = UsageAttributionTagNames


class HourlyUsageAttributionBody(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "hour": (datetime,),
            "org_name": (str,),
            "public_id": (str,),
            "tag_config_source": (str,),
            "tags": (UsageAttributionTagNames,),
            "total_usage_sum": (float,),
            "updated_at": (str,),
            "usage_type": (HourlyUsageAttributionUsageType,),
        }

    attribute_map = {
        "hour": "hour",
        "org_name": "org_name",
        "public_id": "public_id",
        "tag_config_source": "tag_config_source",
        "tags": "tags",
        "total_usage_sum": "total_usage_sum",
        "updated_at": "updated_at",
        "usage_type": "usage_type",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """HourlyUsageAttributionBody - a model defined in OpenAPI

        Keyword Args:
            hour (datetime): [optional] The hour for the usage.
            org_name (str): [optional] The name of the organization.
            public_id (str): [optional] The organization public ID.
            tag_config_source (str): [optional] The source of the usage attribution tag configuration and the selected tags in the format of `<source_org_name>:::<selected tag 1>///<selected tag 2>///<selected tag 3>`.
            tags (UsageAttributionTagNames): [optional]
            total_usage_sum (float): [optional] Total product usage for the given tags within the hour.
            updated_at (str): [optional] Shows the most recent hour in the current month for all organizations where usages are calculated.
            usage_type (HourlyUsageAttributionUsageType): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(HourlyUsageAttributionBody, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
