# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.image_widget_definition_type import ImageWidgetDefinitionType
    from datadog_api_client.v1.model.widget_horizontal_align import WidgetHorizontalAlign
    from datadog_api_client.v1.model.widget_image_sizing import WidgetImageSizing
    from datadog_api_client.v1.model.widget_margin import WidgetMargin
    from datadog_api_client.v1.model.widget_vertical_align import WidgetVerticalAlign

    globals()["ImageWidgetDefinitionType"] = ImageWidgetDefinitionType
    globals()["WidgetHorizontalAlign"] = WidgetHorizontalAlign
    globals()["WidgetImageSizing"] = WidgetImageSizing
    globals()["WidgetMargin"] = WidgetMargin
    globals()["WidgetVerticalAlign"] = WidgetVerticalAlign


class ImageWidgetDefinition(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "has_background": (bool,),
            "has_border": (bool,),
            "horizontal_align": (WidgetHorizontalAlign,),
            "margin": (WidgetMargin,),
            "sizing": (WidgetImageSizing,),
            "type": (ImageWidgetDefinitionType,),
            "url": (str,),
            "url_dark_theme": (str,),
            "vertical_align": (WidgetVerticalAlign,),
        }

    attribute_map = {
        "type": "type",
        "url": "url",
        "has_background": "has_background",
        "has_border": "has_border",
        "horizontal_align": "horizontal_align",
        "margin": "margin",
        "sizing": "sizing",
        "url_dark_theme": "url_dark_theme",
        "vertical_align": "vertical_align",
    }

    read_only_vars = {}

    def __init__(self, type, url, *args, **kwargs):
        """ImageWidgetDefinition - a model defined in OpenAPI

        Args:
            type (ImageWidgetDefinitionType):
            url (str): URL of the image.

        Keyword Args:
            has_background (bool): [optional] Whether to display a background or not. If omitted the server will use the default value of True.
            has_border (bool): [optional] Whether to display a border or not. If omitted the server will use the default value of True.
            horizontal_align (WidgetHorizontalAlign): [optional]
            margin (WidgetMargin): [optional]
            sizing (WidgetImageSizing): [optional]
            url_dark_theme (str): [optional] URL of the image in dark mode.
            vertical_align (WidgetVerticalAlign): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.type = type
        self.url = url

    @classmethod
    def _from_openapi_data(cls, type, url, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(ImageWidgetDefinition, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.type = type
        self.url = url
        return self
