# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.widget_sort import WidgetSort

    globals()["WidgetSort"] = WidgetSort


class LogQueryDefinitionGroupBySort(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "aggregation": (str,),
            "facet": (str,),
            "order": (WidgetSort,),
        }

    attribute_map = {
        "aggregation": "aggregation",
        "order": "order",
        "facet": "facet",
    }

    read_only_vars = {}

    def __init__(self, aggregation, order, *args, **kwargs):
        """LogQueryDefinitionGroupBySort - a model defined in OpenAPI

        Args:
            aggregation (str): The aggregation method.
            order (WidgetSort):

        Keyword Args:
            facet (str): [optional] Facet name.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.aggregation = aggregation
        self.order = order

    @classmethod
    def _from_openapi_data(cls, aggregation, order, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(LogQueryDefinitionGroupBySort, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.aggregation = aggregation
        self.order = order
        return self
