# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.logs_arithmetic_processor_type import LogsArithmeticProcessorType

    globals()["LogsArithmeticProcessorType"] = LogsArithmeticProcessorType


class LogsArithmeticProcessor(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "expression": (str,),
            "is_enabled": (bool,),
            "is_replace_missing": (bool,),
            "name": (str,),
            "target": (str,),
            "type": (LogsArithmeticProcessorType,),
        }

    attribute_map = {
        "expression": "expression",
        "target": "target",
        "type": "type",
        "is_enabled": "is_enabled",
        "is_replace_missing": "is_replace_missing",
        "name": "name",
    }

    read_only_vars = {}

    def __init__(self, expression, target, type, *args, **kwargs):
        """LogsArithmeticProcessor - a model defined in OpenAPI

        Args:
            expression (str): Arithmetic operation between one or more log attributes.
            target (str): Name of the attribute that contains the result of the arithmetic operation.
            type (LogsArithmeticProcessorType):

        Keyword Args:
            is_enabled (bool): [optional] Whether or not the processor is enabled. If omitted the server will use the default value of False.
            is_replace_missing (bool): [optional] If `true`, it replaces all missing attributes of expression by `0`, `false` skip the operation if an attribute is missing. If omitted the server will use the default value of False.
            name (str): [optional] Name of the processor.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.expression = expression
        self.target = target
        self.type = type

    @classmethod
    def _from_openapi_data(cls, expression, target, type, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(LogsArithmeticProcessor, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.expression = expression
        self.target = target
        self.type = type
        return self
