# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.logs_grok_parser_rules import LogsGrokParserRules
    from datadog_api_client.v1.model.logs_grok_parser_type import LogsGrokParserType

    globals()["LogsGrokParserRules"] = LogsGrokParserRules
    globals()["LogsGrokParserType"] = LogsGrokParserType


class LogsGrokParser(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {
        "samples": {
            "max_items": 5,
        },
    }

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "grok": (LogsGrokParserRules,),
            "is_enabled": (bool,),
            "name": (str,),
            "samples": ([str],),
            "source": (str,),
            "type": (LogsGrokParserType,),
        }

    attribute_map = {
        "grok": "grok",
        "source": "source",
        "type": "type",
        "is_enabled": "is_enabled",
        "name": "name",
        "samples": "samples",
    }

    read_only_vars = {}

    def __init__(self, grok, type, *args, **kwargs):
        """LogsGrokParser - a model defined in OpenAPI

        Args:
            grok (LogsGrokParserRules):
            type (LogsGrokParserType):

        Keyword Args:
            source (str): Name of the log attribute to parse. Defaults to "message".
            is_enabled (bool): [optional] Whether or not the processor is enabled. If omitted the server will use the default value of False.
            name (str): [optional] Name of the processor.
            samples ([str]): [optional] List of sample logs to test this grok parser.
        """
        super().__init__(kwargs)

        source = kwargs.get("source", "message")

        self._check_pos_args(args)

        self.grok = grok
        self.source = source
        self.type = type

    @classmethod
    def _from_openapi_data(cls, grok, type, *args, **kwargs):
        """Helper creating a new instance from a response."""
        source = kwargs.get("source", "message")

        self = super(LogsGrokParser, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.grok = grok
        self.source = source
        self.type = type
        return self
