# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.logs_list_request_time import LogsListRequestTime
    from datadog_api_client.v1.model.logs_sort import LogsSort

    globals()["LogsListRequestTime"] = LogsListRequestTime
    globals()["LogsSort"] = LogsSort


class LogsListRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {
        "limit": {
            "inclusive_maximum": 1000,
        },
    }

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "index": (str,),
            "limit": (int,),
            "query": (str,),
            "sort": (LogsSort,),
            "start_at": (str,),
            "time": (LogsListRequestTime,),
        }

    attribute_map = {
        "time": "time",
        "index": "index",
        "limit": "limit",
        "query": "query",
        "sort": "sort",
        "start_at": "startAt",
    }

    read_only_vars = {}

    def __init__(self, time, *args, **kwargs):
        """LogsListRequest - a model defined in OpenAPI

        Args:
            time (LogsListRequestTime):

        Keyword Args:
            index (str): [optional] The log index on which the request is performed. For multi-index organizations, the default is all live indexes. Historical indexes of rehydrated logs must be specified.
            limit (int): [optional] Number of logs return in the response.
            query (str): [optional] The search query - following the log search syntax.
            sort (LogsSort): [optional]
            start_at (str): [optional] Hash identifier of the first log to return in the list, available in a log `id` attribute. This parameter is used for the pagination feature.  **Note**: This parameter is ignored if the corresponding log is out of the scope of the specified time window.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.time = time

    @classmethod
    def _from_openapi_data(cls, time, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(LogsListRequest, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.time = time
        return self
