# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    datetime,
)


class LogsListRequestTime(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "_from": (datetime,),
            "timezone": (str,),
            "to": (datetime,),
        }

    attribute_map = {
        "_from": "from",
        "to": "to",
        "timezone": "timezone",
    }

    read_only_vars = {}

    def __init__(self, _from, to, *args, **kwargs):
        """LogsListRequestTime - a model defined in OpenAPI

        Args:
            _from (datetime): Minimum timestamp for requested logs.
            to (datetime): Maximum timestamp for requested logs.

        Keyword Args:
            timezone (str): [optional] Timezone can be specified both as an offset (for example \"UTC+03:00\") or a regional zone (for example \"Europe/Paris\").
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self._from = _from
        self.to = to

    @classmethod
    def _from_openapi_data(cls, _from, to, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(LogsListRequestTime, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self._from = _from
        self.to = to
        return self
