# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class MetricsListResponse(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "_from": (str,),
            "metrics": ([str],),
        }

    attribute_map = {
        "_from": "from",
        "metrics": "metrics",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """MetricsListResponse - a model defined in OpenAPI

        Keyword Args:
            _from (str): [optional] Time when the metrics were active, seconds since the Unix epoch.
            metrics ([str]): [optional] List of metric names.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(MetricsListResponse, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
