# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class MonitorOptionsAggregation(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "group_by": (str,),
            "metric": (str,),
            "type": (str,),
        }

    attribute_map = {
        "group_by": "group_by",
        "metric": "metric",
        "type": "type",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """MonitorOptionsAggregation - a model defined in OpenAPI

        Keyword Args:
            group_by (str): [optional] Group to break down the monitor on.
            metric (str): [optional] Metric name used in the monitor.
            type (str): [optional] Metric type used in the monitor.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(MonitorOptionsAggregation, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
