# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.monitor_overall_states import MonitorOverallStates

    globals()["MonitorOverallStates"] = MonitorOverallStates


class MonitorStateGroup(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "last_nodata_ts": (int,),
            "last_notified_ts": (int,),
            "last_resolved_ts": (int,),
            "last_triggered_ts": (int,),
            "name": (str,),
            "status": (MonitorOverallStates,),
        }

    attribute_map = {
        "last_nodata_ts": "last_nodata_ts",
        "last_notified_ts": "last_notified_ts",
        "last_resolved_ts": "last_resolved_ts",
        "last_triggered_ts": "last_triggered_ts",
        "name": "name",
        "status": "status",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """MonitorStateGroup - a model defined in OpenAPI

        Keyword Args:
            last_nodata_ts (int): [optional] Latest timestamp the monitor was in NO_DATA state.
            last_notified_ts (int): [optional] Latest timestamp of the notification sent for this monitor group.
            last_resolved_ts (int): [optional] Latest timestamp the monitor group was resolved.
            last_triggered_ts (int): [optional] Latest timestamp the monitor group triggered.
            name (str): [optional] The name of the monitor.
            status (MonitorOverallStates): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(MonitorStateGroup, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
