# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    none_type,
)


class MonitorThresholds(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "critical": (float,),
            "critical_recovery": (
                float,
                none_type,
            ),
            "ok": (
                float,
                none_type,
            ),
            "unknown": (
                float,
                none_type,
            ),
            "warning": (
                float,
                none_type,
            ),
            "warning_recovery": (
                float,
                none_type,
            ),
        }

    attribute_map = {
        "critical": "critical",
        "critical_recovery": "critical_recovery",
        "ok": "ok",
        "unknown": "unknown",
        "warning": "warning",
        "warning_recovery": "warning_recovery",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """MonitorThresholds - a model defined in OpenAPI

        Keyword Args:
            critical (float): [optional] The monitor `CRITICAL` threshold.
            critical_recovery (float, none_type): [optional] The monitor `CRITICAL` recovery threshold.
            ok (float, none_type): [optional] The monitor `OK` threshold.
            unknown (float, none_type): [optional] The monitor UNKNOWN threshold.
            warning (float, none_type): [optional] The monitor `WARNING` threshold.
            warning_recovery (float, none_type): [optional] The monitor `WARNING` recovery threshold.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(MonitorThresholds, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
