# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    datetime,
)


def lazy_import():
    from datadog_api_client.v1.model.monthly_usage_attribution_values import MonthlyUsageAttributionValues
    from datadog_api_client.v1.model.usage_attribution_tag_names import UsageAttributionTagNames

    globals()["MonthlyUsageAttributionValues"] = MonthlyUsageAttributionValues
    globals()["UsageAttributionTagNames"] = UsageAttributionTagNames


class MonthlyUsageAttributionBody(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "month": (datetime,),
            "org_name": (str,),
            "public_id": (str,),
            "tag_config_source": (str,),
            "tags": (UsageAttributionTagNames,),
            "updated_at": (datetime,),
            "values": (MonthlyUsageAttributionValues,),
        }

    attribute_map = {
        "month": "month",
        "org_name": "org_name",
        "public_id": "public_id",
        "tag_config_source": "tag_config_source",
        "tags": "tags",
        "updated_at": "updated_at",
        "values": "values",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """MonthlyUsageAttributionBody - a model defined in OpenAPI

        Keyword Args:
            month (datetime): [optional] Datetime in ISO-8601 format, UTC, precise to month: [YYYY-MM].
            org_name (str): [optional] The name of the organization.
            public_id (str): [optional] The organization public ID.
            tag_config_source (str): [optional] The source of the usage attribution tag configuration and the selected tags in the format `<source_org_name>:<selected tag 1>///<selected tag 2>///<selected tag 3>`.
            tags (UsageAttributionTagNames): [optional]
            updated_at (datetime): [optional] Datetime of the most recent update to the usage values.
            values (MonthlyUsageAttributionValues): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(MonthlyUsageAttributionBody, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
