# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.note_widget_definition_type import NoteWidgetDefinitionType
    from datadog_api_client.v1.model.widget_text_align import WidgetTextAlign
    from datadog_api_client.v1.model.widget_tick_edge import WidgetTickEdge
    from datadog_api_client.v1.model.widget_vertical_align import WidgetVerticalAlign

    globals()["NoteWidgetDefinitionType"] = NoteWidgetDefinitionType
    globals()["WidgetTextAlign"] = WidgetTextAlign
    globals()["WidgetTickEdge"] = WidgetTickEdge
    globals()["WidgetVerticalAlign"] = WidgetVerticalAlign


class NoteWidgetDefinition(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "background_color": (str,),
            "content": (str,),
            "font_size": (str,),
            "has_padding": (bool,),
            "show_tick": (bool,),
            "text_align": (WidgetTextAlign,),
            "tick_edge": (WidgetTickEdge,),
            "tick_pos": (str,),
            "type": (NoteWidgetDefinitionType,),
            "vertical_align": (WidgetVerticalAlign,),
        }

    attribute_map = {
        "content": "content",
        "type": "type",
        "background_color": "background_color",
        "font_size": "font_size",
        "has_padding": "has_padding",
        "show_tick": "show_tick",
        "text_align": "text_align",
        "tick_edge": "tick_edge",
        "tick_pos": "tick_pos",
        "vertical_align": "vertical_align",
    }

    read_only_vars = {}

    def __init__(self, content, type, *args, **kwargs):
        """NoteWidgetDefinition - a model defined in OpenAPI

        Args:
            content (str): Content of the note.
            type (NoteWidgetDefinitionType):

        Keyword Args:
            background_color (str): [optional] Background color of the note.
            font_size (str): [optional] Size of the text.
            has_padding (bool): [optional] Whether to add padding or not. If omitted the server will use the default value of True.
            show_tick (bool): [optional] Whether to show a tick or not.
            text_align (WidgetTextAlign): [optional]
            tick_edge (WidgetTickEdge): [optional]
            tick_pos (str): [optional] Where to position the tick on an edge.
            vertical_align (WidgetVerticalAlign): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.content = content
        self.type = type

    @classmethod
    def _from_openapi_data(cls, content, type, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(NoteWidgetDefinition, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.content = content
        self.type = type
        return self
