# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelSimple,
    cached_property,
)


class NotebookMetadataType(ModelSimple):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    allowed_values = {
        "value": {
            "None": None,
            "POSTMORTEM": "postmortem",
            "RUNBOOK": "runbook",
            "INVESTIGATION": "investigation",
            "DOCUMENTATION": "documentation",
            "REPORT": "report",
        },
    }

    validations = {}

    _nullable = True

    @cached_property
    def openapi_types():
        return {
            "value": (str,),
        }

    def __init__(self, *args, **kwargs):
        """NotebookMetadataType - a model defined in OpenAPI

        Note that value can be passed either in args or in kwargs, but not in both.

        Args:
            args[0] (str): Metadata type of the notebook. If omitted defaults to "null". Must be one of ["postmortem", "runbook", "investigation", "documentation", "report"].

        Keyword Args:
            value (str): Metadata type of the notebook. If omitted defaults to "null". Must be one of ["postmortem", "runbook", "investigation", "documentation", "report"].
        """
        super().__init__(kwargs)

        if "value" in kwargs:
            value = kwargs.pop("value")
        elif args:
            args = list(args)
            value = args.pop(0)
        else:
            value = "null"

        self._check_pos_args(args)

        self.value = value

        self._check_kw_args(kwargs)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""
        return cls(*args, **kwargs)
