# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.notebooks_response_data import NotebooksResponseData
    from datadog_api_client.v1.model.notebooks_response_meta import NotebooksResponseMeta

    globals()["NotebooksResponseData"] = NotebooksResponseData
    globals()["NotebooksResponseMeta"] = NotebooksResponseMeta


class NotebooksResponse(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "data": ([NotebooksResponseData],),
            "meta": (NotebooksResponseMeta,),
        }

    attribute_map = {
        "data": "data",
        "meta": "meta",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """NotebooksResponse - a model defined in OpenAPI

        Keyword Args:
            data ([NotebooksResponseData]): [optional] List of notebook definitions.
            meta (NotebooksResponseMeta): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(NotebooksResponse, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
