# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.scatterplot_dimension import ScatterplotDimension

    globals()["ScatterplotDimension"] = ScatterplotDimension


class ScatterplotWidgetFormula(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "alias": (str,),
            "dimension": (ScatterplotDimension,),
            "formula": (str,),
        }

    attribute_map = {
        "dimension": "dimension",
        "formula": "formula",
        "alias": "alias",
    }

    read_only_vars = {}

    def __init__(self, dimension, formula, *args, **kwargs):
        """ScatterplotWidgetFormula - a model defined in OpenAPI

        Args:
            dimension (ScatterplotDimension):
            formula (str): String expression built from queries, formulas, and functions.

        Keyword Args:
            alias (str): [optional] Expression alias.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.dimension = dimension
        self.formula = formula

    @classmethod
    def _from_openapi_data(cls, dimension, formula, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(ScatterplotWidgetFormula, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.dimension = dimension
        self.formula = formula
        return self
