# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    none_type,
)


def lazy_import():
    from datadog_api_client.v1.model.point import Point

    globals()["Point"] = Point


class Series(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "host": (str,),
            "interval": (
                int,
                none_type,
            ),
            "metric": (str,),
            "points": ([Point],),
            "tags": ([str],),
            "type": (str,),
        }

    attribute_map = {
        "metric": "metric",
        "points": "points",
        "host": "host",
        "interval": "interval",
        "tags": "tags",
        "type": "type",
    }

    read_only_vars = {}

    def __init__(self, metric, points, *args, **kwargs):
        """Series - a model defined in OpenAPI

        Args:
            metric (str): The name of the timeseries.
            points ([Point]): Points relating to a metric. All points must be tuples with timestamp and a scalar value (cannot be a string). Timestamps should be in POSIX time in seconds, and cannot be more than ten minutes in the future or more than one hour in the past.

        Keyword Args:
            host (str): [optional] The name of the host that produced the metric.
            interval (int, none_type): [optional] If the type of the metric is rate or count, define the corresponding interval.
            tags ([str]): [optional] A list of tags associated with the metric.
            type (str): [optional] The type of the metric either `count`, `gauge`, or `rate`. If omitted the server will use the default value of "gauge".
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.metric = metric
        self.points = points

    @classmethod
    def _from_openapi_data(cls, metric, points, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(Series, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.metric = metric
        self.points = points
        return self
