# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class SlackIntegrationChannelDisplay(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "message": (bool,),
            "notified": (bool,),
            "snapshot": (bool,),
            "tags": (bool,),
        }

    attribute_map = {
        "message": "message",
        "notified": "notified",
        "snapshot": "snapshot",
        "tags": "tags",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """SlackIntegrationChannelDisplay - a model defined in OpenAPI

        Keyword Args:
            message (bool): [optional] Show the main body of the alert event. If omitted the server will use the default value of True.
            notified (bool): [optional] Show the list of @-handles in the alert event. If omitted the server will use the default value of True.
            snapshot (bool): [optional] Show the alert event's snapshot image. If omitted the server will use the default value of True.
            tags (bool): [optional] Show the scopes on which the monitor alerted. If omitted the server will use the default value of True.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SlackIntegrationChannelDisplay, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
