# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class SLOHistoryResponseErrorWithType(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "error_message": (str,),
            "error_type": (str,),
        }

    attribute_map = {
        "error_message": "error_message",
        "error_type": "error_type",
    }

    read_only_vars = {}

    def __init__(self, error_message, error_type, *args, **kwargs):
        """SLOHistoryResponseErrorWithType - a model defined in OpenAPI

        Args:
            error_message (str): A message with more details about the error.
            error_type (str): Type of the error.

        Keyword Args:
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.error_message = error_message
        self.error_type = error_type

    @classmethod
    def _from_openapi_data(cls, error_message, error_type, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SLOHistoryResponseErrorWithType, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.error_message = error_message
        self.error_type = error_type
        return self
