# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.slo_error_budget_remaining_data import SLOErrorBudgetRemainingData
    from datadog_api_client.v1.model.slo_history_response_error_with_type import SLOHistoryResponseErrorWithType

    globals()["SLOErrorBudgetRemainingData"] = SLOErrorBudgetRemainingData
    globals()["SLOHistoryResponseErrorWithType"] = SLOHistoryResponseErrorWithType


class SLOHistorySLIData(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "error_budget_remaining": (SLOErrorBudgetRemainingData,),
            "errors": ([SLOHistoryResponseErrorWithType],),
            "group": (str,),
            "history": ([[float]],),
            "monitor_modified": (int,),
            "monitor_type": (str,),
            "name": (str,),
            "precision": ({str: (float,)},),
            "preview": (bool,),
            "sli_value": (float,),
            "span_precision": (float,),
            "uptime": (float,),
        }

    attribute_map = {
        "error_budget_remaining": "error_budget_remaining",
        "errors": "errors",
        "group": "group",
        "history": "history",
        "monitor_modified": "monitor_modified",
        "monitor_type": "monitor_type",
        "name": "name",
        "precision": "precision",
        "preview": "preview",
        "sli_value": "sli_value",
        "span_precision": "span_precision",
        "uptime": "uptime",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """SLOHistorySLIData - a model defined in OpenAPI

        Keyword Args:
            error_budget_remaining (SLOErrorBudgetRemainingData): [optional]
            errors ([SLOHistoryResponseErrorWithType]): [optional] An array of error objects returned while querying the history data for the service level objective.
            group (str): [optional] For groups in a grouped SLO, this is the group name.
            history ([[float]]): [optional] For `monitor` based SLOs, this includes the aggregated history as arrays that include time series and uptime data where `0=monitor` is in `OK` state and `1=monitor` is in `alert` state.
            monitor_modified (int): [optional] For `monitor` based SLOs, this is the last modified timestamp in epoch seconds of the monitor.
            monitor_type (str): [optional] For `monitor` based SLOs, this describes the type of monitor.
            name (str): [optional] For groups in a grouped SLO, this is the group name. For monitors in a multi-monitor SLO, this is the monitor name.
            precision ({str: (float,)}): [optional] A mapping of threshold `timeframe` to number of accurate decimals, regardless of the from && to timestamp.
            preview (bool): [optional] For `monitor` based SLOs, when `true` this indicates that a replay is in progress to give an accurate uptime calculation.
            sli_value (float): [optional] The current SLI value of the SLO over the history window.
            span_precision (float): [optional] The amount of decimal places the SLI value is accurate to for the given from `&&` to timestamp.
            uptime (float): [optional] Use `sli_value` instead.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SLOHistorySLIData, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
