# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.slo_timeframe import SLOTimeframe

    globals()["SLOTimeframe"] = SLOTimeframe


class SLOThreshold(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "target": (float,),
            "target_display": (str,),
            "timeframe": (SLOTimeframe,),
            "warning": (float,),
            "warning_display": (str,),
        }

    attribute_map = {
        "target": "target",
        "timeframe": "timeframe",
        "target_display": "target_display",
        "warning": "warning",
        "warning_display": "warning_display",
    }

    read_only_vars = {}

    def __init__(self, target, timeframe, *args, **kwargs):
        """SLOThreshold - a model defined in OpenAPI

        Args:
            target (float): The target value for the service level indicator within the corresponding timeframe.
            timeframe (SLOTimeframe):

        Keyword Args:
            target_display (str): [optional] A string representation of the target that indicates its precision. It uses trailing zeros to show significant decimal places (for example `98.00`).  Always included in service level objective responses. Ignored in create/update requests.
            warning (float): [optional] The warning value for the service level objective.
            warning_display (str): [optional] A string representation of the warning target (see the description of the `target_display` field for details).  Included in service level objective responses if a warning target exists. Ignored in create/update requests.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.target = target
        self.timeframe = timeframe

    @classmethod
    def _from_openapi_data(cls, target, timeframe, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SLOThreshold, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.target = target
        self.timeframe = timeframe
        return self
