# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.synthetics_api_test_config import SyntheticsAPITestConfig
    from datadog_api_client.v1.model.synthetics_api_test_type import SyntheticsAPITestType
    from datadog_api_client.v1.model.synthetics_test_details_sub_type import SyntheticsTestDetailsSubType
    from datadog_api_client.v1.model.synthetics_test_options import SyntheticsTestOptions
    from datadog_api_client.v1.model.synthetics_test_pause_status import SyntheticsTestPauseStatus

    globals()["SyntheticsAPITestConfig"] = SyntheticsAPITestConfig
    globals()["SyntheticsAPITestType"] = SyntheticsAPITestType
    globals()["SyntheticsTestDetailsSubType"] = SyntheticsTestDetailsSubType
    globals()["SyntheticsTestOptions"] = SyntheticsTestOptions
    globals()["SyntheticsTestPauseStatus"] = SyntheticsTestPauseStatus


class SyntheticsAPITest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "config": (SyntheticsAPITestConfig,),
            "locations": ([str],),
            "message": (str,),
            "monitor_id": (int,),
            "name": (str,),
            "options": (SyntheticsTestOptions,),
            "public_id": (str,),
            "status": (SyntheticsTestPauseStatus,),
            "subtype": (SyntheticsTestDetailsSubType,),
            "tags": ([str],),
            "type": (SyntheticsAPITestType,),
        }

    attribute_map = {
        "config": "config",
        "locations": "locations",
        "name": "name",
        "options": "options",
        "type": "type",
        "message": "message",
        "monitor_id": "monitor_id",
        "public_id": "public_id",
        "status": "status",
        "subtype": "subtype",
        "tags": "tags",
    }

    read_only_vars = {
        "monitor_id",
        "public_id",
    }

    def __init__(self, config, locations, name, options, type, *args, **kwargs):
        """SyntheticsAPITest - a model defined in OpenAPI

        Args:
            config (SyntheticsAPITestConfig):
            locations ([str]): Array of locations used to run the test.
            name (str): Name of the test.
            options (SyntheticsTestOptions):
            type (SyntheticsAPITestType):

        Keyword Args:
            message (str): [optional] Notification message associated with the test.
            monitor_id (int): [optional] The associated monitor ID.
            public_id (str): [optional] The public ID for the test.
            status (SyntheticsTestPauseStatus): [optional]
            subtype (SyntheticsTestDetailsSubType): [optional]
            tags ([str]): [optional] Array of tags attached to the test.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.config = config
        self.locations = locations
        self.name = name
        self.options = options
        self.type = type

    @classmethod
    def _from_openapi_data(cls, config, locations, name, options, type, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SyntheticsAPITest, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.config = config
        self.locations = locations
        self.name = name
        self.options = options
        self.type = type
        return self
