# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.synthetics_assertion_json_path_operator import SyntheticsAssertionJSONPathOperator
    from datadog_api_client.v1.model.synthetics_assertion_json_path_target_target import (
        SyntheticsAssertionJSONPathTargetTarget,
    )
    from datadog_api_client.v1.model.synthetics_assertion_type import SyntheticsAssertionType

    globals()["SyntheticsAssertionJSONPathOperator"] = SyntheticsAssertionJSONPathOperator
    globals()["SyntheticsAssertionJSONPathTargetTarget"] = SyntheticsAssertionJSONPathTargetTarget
    globals()["SyntheticsAssertionType"] = SyntheticsAssertionType


class SyntheticsAssertionJSONPathTarget(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "operator": (SyntheticsAssertionJSONPathOperator,),
            "_property": (str,),
            "target": (SyntheticsAssertionJSONPathTargetTarget,),
            "type": (SyntheticsAssertionType,),
        }

    attribute_map = {
        "operator": "operator",
        "type": "type",
        "_property": "property",
        "target": "target",
    }

    read_only_vars = {}

    def __init__(self, operator, type, *args, **kwargs):
        """SyntheticsAssertionJSONPathTarget - a model defined in OpenAPI

        Args:
            operator (SyntheticsAssertionJSONPathOperator):
            type (SyntheticsAssertionType):

        Keyword Args:
            _property (str): [optional] The associated assertion property.
            target (SyntheticsAssertionJSONPathTargetTarget): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.operator = operator
        self.type = type

    @classmethod
    def _from_openapi_data(cls, operator, type, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SyntheticsAssertionJSONPathTarget, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.operator = operator
        self.type = type
        return self
