# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    date,
    datetime,
    none_type,
)


class SyntheticsAssertionJSONPathTargetTarget(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "json_path": (str,),
            "operator": (str,),
            "target_value": (
                bool,
                date,
                datetime,
                dict,
                float,
                int,
                list,
                str,
                none_type,
            ),
        }

    attribute_map = {
        "json_path": "jsonPath",
        "operator": "operator",
        "target_value": "targetValue",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """SyntheticsAssertionJSONPathTargetTarget - a model defined in OpenAPI

        Keyword Args:
            json_path (str): [optional] The JSON path to assert.
            operator (str): [optional] The specific operator to use on the path.
            target_value (bool, date, datetime, dict, float, int, list, str, none_type): [optional] The path target value to compare to.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SyntheticsAssertionJSONPathTargetTarget, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
