# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelComposed,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.synthetics_basic_auth_ntlm import SyntheticsBasicAuthNTLM
    from datadog_api_client.v1.model.synthetics_basic_auth_ntlm_type import SyntheticsBasicAuthNTLMType
    from datadog_api_client.v1.model.synthetics_basic_auth_sigv4 import SyntheticsBasicAuthSigv4
    from datadog_api_client.v1.model.synthetics_basic_auth_web import SyntheticsBasicAuthWeb

    globals()["SyntheticsBasicAuthNTLM"] = SyntheticsBasicAuthNTLM
    globals()["SyntheticsBasicAuthNTLMType"] = SyntheticsBasicAuthNTLMType
    globals()["SyntheticsBasicAuthSigv4"] = SyntheticsBasicAuthSigv4
    globals()["SyntheticsBasicAuthWeb"] = SyntheticsBasicAuthWeb


class SyntheticsBasicAuth(ModelComposed):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {}

    def __init__(self, *args, **kwargs):
        """SyntheticsBasicAuth - a model defined in OpenAPI

        Keyword Args:
            region (str): [optional] Region for the `SIGV4` authentication.
            service_name (str): [optional] Service name for the `SIGV4` authentication.
            session_token (str): [optional] Session token for the `SIGV4` authentication.
            domain (str): [optional] Domain for the authentication to use when performing the test.
            workstation (str): [optional] Workstation for the authentication to use when performing the test.
            password (str): [optional] Password for the authentication to use when performing the test.
            type (SyntheticsBasicAuthNTLMType): [optional]
            username (str): [optional] Username for the authentication to use when performing the test.
            access_key (str): [optional] Access key for the `SIGV4` authentication.
            secret_key (str): [optional] Secret key for the `SIGV4` authentication.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SyntheticsBasicAuth, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self

    @cached_property
    def _composed_schemas():
        # we need this here to make our import statements work
        # we must store _composed_schemas in here so the code is only run
        # when we invoke this method. If we kept this at the class
        # level we would get an error because the class level
        # code would be run when this module is imported, and these composed
        # classes don't exist yet because their module has not finished
        # loading
        lazy_import()
        return {
            "anyOf": [],
            "allOf": [],
            "oneOf": [
                SyntheticsBasicAuthNTLM,
                SyntheticsBasicAuthSigv4,
                SyntheticsBasicAuthWeb,
            ],
        }
