# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.synthetics_basic_auth_sigv4_type import SyntheticsBasicAuthSigv4Type

    globals()["SyntheticsBasicAuthSigv4Type"] = SyntheticsBasicAuthSigv4Type


class SyntheticsBasicAuthSigv4(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "access_key": (str,),
            "region": (str,),
            "secret_key": (str,),
            "service_name": (str,),
            "session_token": (str,),
            "type": (SyntheticsBasicAuthSigv4Type,),
        }

    attribute_map = {
        "access_key": "accessKey",
        "secret_key": "secretKey",
        "type": "type",
        "region": "region",
        "service_name": "serviceName",
        "session_token": "sessionToken",
    }

    read_only_vars = {}

    def __init__(self, access_key, secret_key, type, *args, **kwargs):
        """SyntheticsBasicAuthSigv4 - a model defined in OpenAPI

        Args:
            access_key (str): Access key for the `SIGV4` authentication.
            secret_key (str): Secret key for the `SIGV4` authentication.
            type (SyntheticsBasicAuthSigv4Type):

        Keyword Args:
            region (str): [optional] Region for the `SIGV4` authentication.
            service_name (str): [optional] Service name for the `SIGV4` authentication.
            session_token (str): [optional] Session token for the `SIGV4` authentication.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.access_key = access_key
        self.secret_key = secret_key
        self.type = type

    @classmethod
    def _from_openapi_data(cls, access_key, secret_key, type, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SyntheticsBasicAuthSigv4, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.access_key = access_key
        self.secret_key = secret_key
        self.type = type
        return self
