# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.synthetics_device_id import SyntheticsDeviceID
    from datadog_api_client.v1.model.synthetics_status import SyntheticsStatus
    from datadog_api_client.v1.model.synthetics_test_details_type import SyntheticsTestDetailsType
    from datadog_api_client.v1.model.synthetics_test_execution_rule import SyntheticsTestExecutionRule

    globals()["SyntheticsDeviceID"] = SyntheticsDeviceID
    globals()["SyntheticsStatus"] = SyntheticsStatus
    globals()["SyntheticsTestDetailsType"] = SyntheticsTestDetailsType
    globals()["SyntheticsTestExecutionRule"] = SyntheticsTestExecutionRule


class SyntheticsBatchResult(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "device": (SyntheticsDeviceID,),
            "duration": (float,),
            "execution_rule": (SyntheticsTestExecutionRule,),
            "location": (str,),
            "result_id": (str,),
            "retries": (float,),
            "status": (SyntheticsStatus,),
            "test_name": (str,),
            "test_public_id": (str,),
            "test_type": (SyntheticsTestDetailsType,),
        }

    attribute_map = {
        "device": "device",
        "duration": "duration",
        "execution_rule": "execution_rule",
        "location": "location",
        "result_id": "result_id",
        "retries": "retries",
        "status": "status",
        "test_name": "test_name",
        "test_public_id": "test_public_id",
        "test_type": "test_type",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """SyntheticsBatchResult - a model defined in OpenAPI

        Keyword Args:
            device (SyntheticsDeviceID): [optional]
            duration (float): [optional] Total duration in millisecond of the test.
            execution_rule (SyntheticsTestExecutionRule): [optional]
            location (str): [optional] Name of the location.
            result_id (str): [optional] The ID of the result to get.
            retries (float): [optional] Total duration in millisecond of the test.
            status (SyntheticsStatus): [optional]
            test_name (str): [optional] Name of the test.
            test_public_id (str): [optional] The public ID of the Synthetic test.
            test_type (SyntheticsTestDetailsType): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SyntheticsBatchResult, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
