# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.synthetics_device import SyntheticsDevice

    globals()["SyntheticsDevice"] = SyntheticsDevice


class SyntheticsBrowserTestResultShortResult(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "device": (SyntheticsDevice,),
            "duration": (float,),
            "error_count": (int,),
            "step_count_completed": (int,),
            "step_count_total": (int,),
        }

    attribute_map = {
        "device": "device",
        "duration": "duration",
        "error_count": "errorCount",
        "step_count_completed": "stepCountCompleted",
        "step_count_total": "stepCountTotal",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """SyntheticsBrowserTestResultShortResult - a model defined in OpenAPI

        Keyword Args:
            device (SyntheticsDevice): [optional]
            duration (float): [optional] Length in second of the browser test run.
            error_count (int): [optional] Amount of errors collected for a single browser test run.
            step_count_completed (int): [optional] Amount of browser test steps completed before failing.
            step_count_total (int): [optional] Total amount of browser test steps.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SyntheticsBrowserTestResultShortResult, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
