# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class SyntheticsSSLCertificateIssuer(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "c": (str,),
            "cn": (str,),
            "l": (str,),
            "o": (str,),
            "ou": (str,),
            "st": (str,),
        }

    attribute_map = {
        "c": "C",
        "cn": "CN",
        "l": "L",
        "o": "O",
        "ou": "OU",
        "st": "ST",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """SyntheticsSSLCertificateIssuer - a model defined in OpenAPI

        Keyword Args:
            c (str): [optional] Country Name that issued the certificate.
            cn (str): [optional] Common Name that issued certificate.
            l (str): [optional] Locality that issued the certificate.
            o (str): [optional] Organization that issued the certificate.
            ou (str): [optional] Organizational Unit that issued the certificate.
            st (str): [optional] State Or Province Name that issued the certificate.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SyntheticsSSLCertificateIssuer, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
