# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.synthetics_step_type import SyntheticsStepType

    globals()["SyntheticsStepType"] = SyntheticsStepType


class SyntheticsStep(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "allow_failure": (bool,),
            "name": (str,),
            "params": (dict,),
            "timeout": (int,),
            "type": (SyntheticsStepType,),
        }

    attribute_map = {
        "allow_failure": "allowFailure",
        "name": "name",
        "params": "params",
        "timeout": "timeout",
        "type": "type",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """SyntheticsStep - a model defined in OpenAPI

        Keyword Args:
            allow_failure (bool): [optional] A boolean set to allow this step to fail.
            name (str): [optional] The name of the step.
            params (dict): [optional] The parameters of the step.
            timeout (int): [optional] The time before declaring a step failed.
            type (SyntheticsStepType): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SyntheticsStep, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
