# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class SyntheticsTestOptionsRetry(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "count": (int,),
            "interval": (float,),
        }

    attribute_map = {
        "count": "count",
        "interval": "interval",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """SyntheticsTestOptionsRetry - a model defined in OpenAPI

        Keyword Args:
            count (int): [optional] Number of times a test needs to be retried before marking a location as failed. Defaults to 0.
            interval (float): [optional] Time interval between retries (in milliseconds). Defaults to 300ms.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SyntheticsTestOptionsRetry, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
