# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class SyntheticsTestRequestCertificateItem(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "content": (str,),
            "filename": (str,),
            "updated_at": (str,),
        }

    attribute_map = {
        "content": "content",
        "filename": "filename",
        "updated_at": "updatedAt",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """SyntheticsTestRequestCertificateItem - a model defined in OpenAPI

        Keyword Args:
            content (str): [optional] Content of the certificate or key.
            filename (str): [optional] File name for the certificate or key.
            updated_at (str): [optional] Date of update of the certificate or key, ISO format.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SyntheticsTestRequestCertificateItem, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
