# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class TimeseriesWidgetExpressionAlias(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "alias_name": (str,),
            "expression": (str,),
        }

    attribute_map = {
        "expression": "expression",
        "alias_name": "alias_name",
    }

    read_only_vars = {}

    def __init__(self, expression, *args, **kwargs):
        """TimeseriesWidgetExpressionAlias - a model defined in OpenAPI

        Args:
            expression (str): Expression name.

        Keyword Args:
            alias_name (str): [optional] Expression alias.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.expression = expression

    @classmethod
    def _from_openapi_data(cls, expression, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(TimeseriesWidgetExpressionAlias, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.expression = expression
        return self
