# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.tree_map_color_by import TreeMapColorBy
    from datadog_api_client.v1.model.tree_map_group_by import TreeMapGroupBy
    from datadog_api_client.v1.model.tree_map_size_by import TreeMapSizeBy
    from datadog_api_client.v1.model.tree_map_widget_definition_type import TreeMapWidgetDefinitionType
    from datadog_api_client.v1.model.tree_map_widget_request import TreeMapWidgetRequest

    globals()["TreeMapColorBy"] = TreeMapColorBy
    globals()["TreeMapGroupBy"] = TreeMapGroupBy
    globals()["TreeMapSizeBy"] = TreeMapSizeBy
    globals()["TreeMapWidgetDefinitionType"] = TreeMapWidgetDefinitionType
    globals()["TreeMapWidgetRequest"] = TreeMapWidgetRequest


class TreeMapWidgetDefinition(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {
        "requests": {
            "max_items": 1,
            "min_items": 1,
        },
    }

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "color_by": (TreeMapColorBy,),
            "group_by": (TreeMapGroupBy,),
            "requests": ([TreeMapWidgetRequest],),
            "size_by": (TreeMapSizeBy,),
            "title": (str,),
            "type": (TreeMapWidgetDefinitionType,),
        }

    attribute_map = {
        "requests": "requests",
        "type": "type",
        "color_by": "color_by",
        "group_by": "group_by",
        "size_by": "size_by",
        "title": "title",
    }

    read_only_vars = {}

    def __init__(self, requests, type, *args, **kwargs):
        """TreeMapWidgetDefinition - a model defined in OpenAPI

        Args:
            requests ([TreeMapWidgetRequest]): List of top list widget requests.
            type (TreeMapWidgetDefinitionType):

        Keyword Args:
            color_by (TreeMapColorBy): [optional]
            group_by (TreeMapGroupBy): [optional]
            size_by (TreeMapSizeBy): [optional]
            title (str): [optional] Title of your widget.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.requests = requests
        self.type = type

    @classmethod
    def _from_openapi_data(cls, requests, type, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(TreeMapWidgetDefinition, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.requests = requests
        self.type = type
        return self
