# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    datetime,
)


class UsageLogsHour(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "billable_ingested_bytes": (int,),
            "hour": (datetime,),
            "indexed_events_count": (int,),
            "ingested_events_bytes": (int,),
            "logs_live_indexed_count": (int,),
            "logs_live_ingested_bytes": (int,),
            "logs_rehydrated_indexed_count": (int,),
            "logs_rehydrated_ingested_bytes": (int,),
        }

    attribute_map = {
        "billable_ingested_bytes": "billable_ingested_bytes",
        "hour": "hour",
        "indexed_events_count": "indexed_events_count",
        "ingested_events_bytes": "ingested_events_bytes",
        "logs_live_indexed_count": "logs_live_indexed_count",
        "logs_live_ingested_bytes": "logs_live_ingested_bytes",
        "logs_rehydrated_indexed_count": "logs_rehydrated_indexed_count",
        "logs_rehydrated_ingested_bytes": "logs_rehydrated_ingested_bytes",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """UsageLogsHour - a model defined in OpenAPI

        Keyword Args:
            billable_ingested_bytes (int): [optional] Contains the number of billable log bytes ingested.
            hour (datetime): [optional] The hour for the usage.
            indexed_events_count (int): [optional] Contains the number of log events indexed.
            ingested_events_bytes (int): [optional] Contains the number of log bytes ingested.
            logs_live_indexed_count (int): [optional] Contains the number of live log events indexed (data available as of December 1, 2020).
            logs_live_ingested_bytes (int): [optional] Contains the number of live log bytes ingested (data available as of December 1, 2020).
            logs_rehydrated_indexed_count (int): [optional] Contains the number of rehydrated log events indexed (data available as of December 1, 2020).
            logs_rehydrated_ingested_bytes (int): [optional] Contains the number of rehydrated log bytes ingested (data available as of December 1, 2020).
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(UsageLogsHour, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
