# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    datetime,
)


class UsageProfilingHour(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "avg_container_agent_count": (int,),
            "host_count": (int,),
            "hour": (datetime,),
        }

    attribute_map = {
        "avg_container_agent_count": "avg_container_agent_count",
        "host_count": "host_count",
        "hour": "hour",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """UsageProfilingHour - a model defined in OpenAPI

        Keyword Args:
            avg_container_agent_count (int): [optional] Get average number of container agents for that hour.
            host_count (int): [optional] Contains the total number of profiled hosts reporting during a given hour.
            hour (datetime): [optional] The hour for the usage.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(UsageProfilingHour, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
