# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    none_type,
)


class UsageRumUnitsHour(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "browser_rum_units": (int,),
            "mobile_rum_units": (int,),
            "org_name": (str,),
            "public_id": (str,),
            "rum_units": (
                int,
                none_type,
            ),
        }

    attribute_map = {
        "browser_rum_units": "browser_rum_units",
        "mobile_rum_units": "mobile_rum_units",
        "org_name": "org_name",
        "public_id": "public_id",
        "rum_units": "rum_units",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """UsageRumUnitsHour - a model defined in OpenAPI

        Keyword Args:
            browser_rum_units (int): [optional] The number of browser RUM units.
            mobile_rum_units (int): [optional] The number of mobile RUM units.
            org_name (str): [optional] The organization name.
            public_id (str): [optional] The organization public ID.
            rum_units (int, none_type): [optional] Total RUM units across mobile and browser RUM.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(UsageRumUnitsHour, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
