# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    datetime,
)


class UsageTimeseriesHour(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "hour": (datetime,),
            "num_custom_input_timeseries": (int,),
            "num_custom_output_timeseries": (int,),
            "num_custom_timeseries": (int,),
        }

    attribute_map = {
        "hour": "hour",
        "num_custom_input_timeseries": "num_custom_input_timeseries",
        "num_custom_output_timeseries": "num_custom_output_timeseries",
        "num_custom_timeseries": "num_custom_timeseries",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """UsageTimeseriesHour - a model defined in OpenAPI

        Keyword Args:
            hour (datetime): [optional] The hour for the usage.
            num_custom_input_timeseries (int): [optional] Contains the number of custom metrics that are inputs for aggregations (metric configured is custom).
            num_custom_output_timeseries (int): [optional] Contains the number of custom metrics that are outputs for aggregations (metric configured is custom).
            num_custom_timeseries (int): [optional] Contains sum of non-aggregation custom metrics and custom metrics that are outputs for aggregations.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(UsageTimeseriesHour, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
