# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    datetime,
)


def lazy_import():
    from datadog_api_client.v1.model.usage_attribution_pagination import UsageAttributionPagination

    globals()["UsageAttributionPagination"] = UsageAttributionPagination


class UsageTopAvgMetricsMetadata(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "day": (datetime,),
            "month": (datetime,),
            "pagination": (UsageAttributionPagination,),
        }

    attribute_map = {
        "day": "day",
        "month": "month",
        "pagination": "pagination",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """UsageTopAvgMetricsMetadata - a model defined in OpenAPI

        Keyword Args:
            day (datetime): [optional] The day value from the user request that contains the returned usage data. (If day was used the request)
            month (datetime): [optional] The month value from the user request that contains the returned usage data. (If month was used the request)
            pagination (UsageAttributionPagination): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(UsageTopAvgMetricsMetadata, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
