# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.usage_top_avg_metrics_hour import UsageTopAvgMetricsHour
    from datadog_api_client.v1.model.usage_top_avg_metrics_metadata import UsageTopAvgMetricsMetadata

    globals()["UsageTopAvgMetricsHour"] = UsageTopAvgMetricsHour
    globals()["UsageTopAvgMetricsMetadata"] = UsageTopAvgMetricsMetadata


class UsageTopAvgMetricsResponse(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "metadata": (UsageTopAvgMetricsMetadata,),
            "usage": ([UsageTopAvgMetricsHour],),
        }

    attribute_map = {
        "metadata": "metadata",
        "usage": "usage",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """UsageTopAvgMetricsResponse - a model defined in OpenAPI

        Keyword Args:
            metadata (UsageTopAvgMetricsMetadata): [optional]
            usage ([UsageTopAvgMetricsHour]): [optional] Number of hourly recorded custom metrics for a given organization.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(UsageTopAvgMetricsResponse, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
