# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
    none_type,
)


def lazy_import():
    from datadog_api_client.v1.model.webhooks_integration_encoding import WebhooksIntegrationEncoding

    globals()["WebhooksIntegrationEncoding"] = WebhooksIntegrationEncoding


class WebhooksIntegration(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "custom_headers": (
                str,
                none_type,
            ),
            "encode_as": (WebhooksIntegrationEncoding,),
            "name": (str,),
            "payload": (
                str,
                none_type,
            ),
            "url": (str,),
        }

    attribute_map = {
        "name": "name",
        "url": "url",
        "custom_headers": "custom_headers",
        "encode_as": "encode_as",
        "payload": "payload",
    }

    read_only_vars = {}

    def __init__(self, name, url, *args, **kwargs):
        """WebhooksIntegration - a model defined in OpenAPI

        Args:
            name (str): The name of the webhook. It corresponds with `<WEBHOOK_NAME>`. Learn more on how to use it in [monitor notifications](https://docs.datadoghq.com/monitors/notify).
            url (str): URL of the webhook.

        Keyword Args:
            custom_headers (str, none_type): [optional] If `null`, uses no header. If given a JSON payload, these will be headers attached to your webhook.
            encode_as (WebhooksIntegrationEncoding): [optional]
            payload (str, none_type): [optional] If `null`, uses the default payload. If given a JSON payload, the webhook returns the payload specified by the given payload. [Webhooks variable usage](https://docs.datadoghq.com/integrations/webhooks/#usage).
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.name = name
        self.url = url

    @classmethod
    def _from_openapi_data(cls, name, url, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(WebhooksIntegration, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.name = name
        self.url = url
        return self
