# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class WidgetLayout(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {
        "height": {
            "inclusive_minimum": 0,
        },
        "width": {
            "inclusive_minimum": 0,
        },
        "x": {
            "inclusive_minimum": 0,
        },
        "y": {
            "inclusive_minimum": 0,
        },
    }

    @cached_property
    def openapi_types():
        return {
            "height": (int,),
            "is_column_break": (bool,),
            "width": (int,),
            "x": (int,),
            "y": (int,),
        }

    attribute_map = {
        "height": "height",
        "width": "width",
        "x": "x",
        "y": "y",
        "is_column_break": "is_column_break",
    }

    read_only_vars = {}

    def __init__(self, height, width, x, y, *args, **kwargs):
        """WidgetLayout - a model defined in OpenAPI

        Args:
            height (int): The height of the widget. Should be a non-negative integer.
            width (int): The width of the widget. Should be a non-negative integer.
            x (int): The position of the widget on the x (horizontal) axis. Should be a non-negative integer.
            y (int): The position of the widget on the y (vertical) axis. Should be a non-negative integer.

        Keyword Args:
            is_column_break (bool): [optional] Whether the widget should be the first one on the second column in high density or not. **Note**: Only for the **new dashboard layout** and only one widget in the dashboard should have this property set to `true`.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.height = height
        self.width = width
        self.x = x
        self.y = y

    @classmethod
    def _from_openapi_data(cls, height, width, x, y, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(WidgetLayout, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.height = height
        self.width = width
        self.x = x
        self.y = y
        return self
