# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


class WidgetMarker(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "display_type": (str,),
            "label": (str,),
            "time": (str,),
            "value": (str,),
        }

    attribute_map = {
        "value": "value",
        "display_type": "display_type",
        "label": "label",
        "time": "time",
    }

    read_only_vars = {}

    def __init__(self, value, *args, **kwargs):
        """WidgetMarker - a model defined in OpenAPI

        Args:
            value (str): Value to apply. Can be a single value y = 15 or a range of values 0 < y < 10.

        Keyword Args:
            display_type (str): [optional] Combination of:   - A severity error, warning, ok, or info   - A line type: dashed, solid, or bold In this case of a Distribution widget, this can be set to be `x_axis_percentile`.
            label (str): [optional] Label to display over the marker.
            time (str): [optional] Timestamp for the widget.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.value = value

    @classmethod
    def _from_openapi_data(cls, value, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(WidgetMarker, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.value = value
        return self
