# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v1.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v1.model.widget_line_type import WidgetLineType
    from datadog_api_client.v1.model.widget_line_width import WidgetLineWidth

    globals()["WidgetLineType"] = WidgetLineType
    globals()["WidgetLineWidth"] = WidgetLineWidth


class WidgetRequestStyle(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "line_type": (WidgetLineType,),
            "line_width": (WidgetLineWidth,),
            "palette": (str,),
        }

    attribute_map = {
        "line_type": "line_type",
        "line_width": "line_width",
        "palette": "palette",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """WidgetRequestStyle - a model defined in OpenAPI

        Keyword Args:
            line_type (WidgetLineType): [optional]
            line_width (WidgetLineWidth): [optional]
            palette (str): [optional] Color palette to apply to the widget.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(WidgetRequestStyle, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
