# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.dashboard_list_item_request import DashboardListItemRequest

    globals()["DashboardListItemRequest"] = DashboardListItemRequest


class DashboardListDeleteItemsRequest(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "dashboards": ([DashboardListItemRequest],),
        }

    attribute_map = {
        "dashboards": "dashboards",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """DashboardListDeleteItemsRequest - a model defined in OpenAPI

        Keyword Args:
            dashboards ([DashboardListItemRequest]): [optional] List of dashboards to delete from the dashboard list.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(DashboardListDeleteItemsRequest, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
