# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.api_key_relationships import APIKeyRelationships
    from datadog_api_client.v2.model.api_keys_type import APIKeysType
    from datadog_api_client.v2.model.full_api_key_attributes import FullAPIKeyAttributes

    globals()["APIKeyRelationships"] = APIKeyRelationships
    globals()["APIKeysType"] = APIKeysType
    globals()["FullAPIKeyAttributes"] = FullAPIKeyAttributes


class FullAPIKey(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "attributes": (FullAPIKeyAttributes,),
            "id": (str,),
            "relationships": (APIKeyRelationships,),
            "type": (APIKeysType,),
        }

    attribute_map = {
        "attributes": "attributes",
        "id": "id",
        "relationships": "relationships",
        "type": "type",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """FullAPIKey - a model defined in OpenAPI

        Keyword Args:
            attributes (FullAPIKeyAttributes): [optional]
            id (str): [optional] ID of the API key.
            relationships (APIKeyRelationships): [optional]
            type (APIKeysType): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(FullAPIKey, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
