# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.application_key_relationships import ApplicationKeyRelationships
    from datadog_api_client.v2.model.application_keys_type import ApplicationKeysType
    from datadog_api_client.v2.model.full_application_key_attributes import FullApplicationKeyAttributes

    globals()["ApplicationKeyRelationships"] = ApplicationKeyRelationships
    globals()["ApplicationKeysType"] = ApplicationKeysType
    globals()["FullApplicationKeyAttributes"] = FullApplicationKeyAttributes


class FullApplicationKey(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "attributes": (FullApplicationKeyAttributes,),
            "id": (str,),
            "relationships": (ApplicationKeyRelationships,),
            "type": (ApplicationKeysType,),
        }

    attribute_map = {
        "attributes": "attributes",
        "id": "id",
        "relationships": "relationships",
        "type": "type",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """FullApplicationKey - a model defined in OpenAPI

        Keyword Args:
            attributes (FullApplicationKeyAttributes): [optional]
            id (str): [optional] ID of the application key.
            relationships (ApplicationKeyRelationships): [optional]
            type (ApplicationKeysType): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(FullApplicationKey, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
