# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
    datetime,
)


class IncidentTeamResponseAttributes(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "created": (datetime,),
            "modified": (datetime,),
            "name": (str,),
        }

    attribute_map = {
        "created": "created",
        "modified": "modified",
        "name": "name",
    }

    read_only_vars = {
        "created",
        "modified",
    }

    def __init__(self, *args, **kwargs):
        """IncidentTeamResponseAttributes - a model defined in OpenAPI

        Keyword Args:
            created (datetime): [optional] Timestamp of when the incident team was created.
            modified (datetime): [optional] Timestamp of when the incident team was modified.
            name (str): [optional] Name of the incident team.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(IncidentTeamResponseAttributes, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
