# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.incident_team_relationships import IncidentTeamRelationships
    from datadog_api_client.v2.model.incident_team_response_attributes import IncidentTeamResponseAttributes
    from datadog_api_client.v2.model.incident_team_type import IncidentTeamType

    globals()["IncidentTeamRelationships"] = IncidentTeamRelationships
    globals()["IncidentTeamResponseAttributes"] = IncidentTeamResponseAttributes
    globals()["IncidentTeamType"] = IncidentTeamType


class IncidentTeamResponseData(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "attributes": (IncidentTeamResponseAttributes,),
            "id": (str,),
            "relationships": (IncidentTeamRelationships,),
            "type": (IncidentTeamType,),
        }

    attribute_map = {
        "attributes": "attributes",
        "id": "id",
        "relationships": "relationships",
        "type": "type",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """IncidentTeamResponseData - a model defined in OpenAPI

        Keyword Args:
            attributes (IncidentTeamResponseAttributes): [optional]
            id (str): [optional] The incident team's ID.
            relationships (IncidentTeamRelationships): [optional]
            type (IncidentTeamType): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(IncidentTeamResponseData, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
