# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.incident_timeline_cell_markdown_content_type import (
        IncidentTimelineCellMarkdownContentType,
    )
    from datadog_api_client.v2.model.incident_timeline_cell_markdown_create_attributes_content import (
        IncidentTimelineCellMarkdownCreateAttributesContent,
    )

    globals()["IncidentTimelineCellMarkdownContentType"] = IncidentTimelineCellMarkdownContentType
    globals()[
        "IncidentTimelineCellMarkdownCreateAttributesContent"
    ] = IncidentTimelineCellMarkdownCreateAttributesContent


class IncidentTimelineCellMarkdownCreateAttributes(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "cell_type": (IncidentTimelineCellMarkdownContentType,),
            "content": (IncidentTimelineCellMarkdownCreateAttributesContent,),
            "important": (bool,),
        }

    attribute_map = {
        "cell_type": "cell_type",
        "content": "content",
        "important": "important",
    }

    read_only_vars = {}

    def __init__(self, cell_type, content, *args, **kwargs):
        """IncidentTimelineCellMarkdownCreateAttributes - a model defined in OpenAPI

        Args:
            cell_type (IncidentTimelineCellMarkdownContentType):
            content (IncidentTimelineCellMarkdownCreateAttributesContent):

        Keyword Args:
            important (bool): [optional] A flag indicating whether the timeline cell is important and should be highlighted. If omitted the server will use the default value of False.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.cell_type = cell_type
        self.content = content

    @classmethod
    def _from_openapi_data(cls, cell_type, content, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(IncidentTimelineCellMarkdownCreateAttributes, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.cell_type = cell_type
        self.content = content
        return self
