# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.logs_aggregate_sort_type import LogsAggregateSortType
    from datadog_api_client.v2.model.logs_aggregation_function import LogsAggregationFunction
    from datadog_api_client.v2.model.logs_sort_order import LogsSortOrder

    globals()["LogsAggregateSortType"] = LogsAggregateSortType
    globals()["LogsAggregationFunction"] = LogsAggregationFunction
    globals()["LogsSortOrder"] = LogsSortOrder


class LogsAggregateSort(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "aggregation": (LogsAggregationFunction,),
            "metric": (str,),
            "order": (LogsSortOrder,),
            "type": (LogsAggregateSortType,),
        }

    attribute_map = {
        "aggregation": "aggregation",
        "metric": "metric",
        "order": "order",
        "type": "type",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """LogsAggregateSort - a model defined in OpenAPI

        Keyword Args:
            aggregation (LogsAggregationFunction): [optional]
            metric (str): [optional] The metric to sort by (only used for `type=measure`)
            order (LogsSortOrder): [optional]
            type (LogsAggregateSortType): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(LogsAggregateSort, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
