# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.logs_archive_create_request_destination import LogsArchiveCreateRequestDestination

    globals()["LogsArchiveCreateRequestDestination"] = LogsArchiveCreateRequestDestination


class LogsArchiveCreateRequestAttributes(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "destination": (LogsArchiveCreateRequestDestination,),
            "include_tags": (bool,),
            "name": (str,),
            "query": (str,),
            "rehydration_tags": ([str],),
        }

    attribute_map = {
        "destination": "destination",
        "name": "name",
        "query": "query",
        "include_tags": "include_tags",
        "rehydration_tags": "rehydration_tags",
    }

    read_only_vars = {}

    def __init__(self, destination, name, query, *args, **kwargs):
        """LogsArchiveCreateRequestAttributes - a model defined in OpenAPI

        Args:
            destination (LogsArchiveCreateRequestDestination):
            name (str): The archive name.
            query (str): The archive query/filter. Logs matching this query are included in the archive.

        Keyword Args:
            include_tags (bool): [optional] To store the tags in the archive, set the value \"true\". If it is set to \"false\", the tags will be deleted when the logs are sent to the archive. If omitted the server will use the default value of False.
            rehydration_tags ([str]): [optional] An array of tags to add to rehydrated logs from an archive.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.destination = destination
        self.name = name
        self.query = query

    @classmethod
    def _from_openapi_data(cls, destination, name, query, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(LogsArchiveCreateRequestAttributes, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.destination = destination
        self.name = name
        self.query = query
        return self
