# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


class LogsListRequestPage(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {
        "limit": {
            "inclusive_maximum": 1000,
        },
    }

    @cached_property
    def openapi_types():
        return {
            "cursor": (str,),
            "limit": (int,),
        }

    attribute_map = {
        "cursor": "cursor",
        "limit": "limit",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """LogsListRequestPage - a model defined in OpenAPI

        Keyword Args:
            cursor (str): [optional] List following results with a cursor provided in the previous query.
            limit (int): [optional] Maximum number of logs in the response. If omitted the server will use the default value of 10.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(LogsListRequestPage, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
