# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


class LogsQueryOptions(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "time_offset": (int,),
            "timezone": (str,),
        }

    attribute_map = {
        "time_offset": "timeOffset",
        "timezone": "timezone",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """LogsQueryOptions - a model defined in OpenAPI

        Keyword Args:
            time_offset (int): [optional] The time offset (in seconds) to apply to the query.
            timezone (str): [optional] The timezone can be specified both as an offset, for example: \"UTC+03:00\". If omitted the server will use the default value of "UTC".
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(LogsQueryOptions, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
