# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


class LogsWarning(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "code": (str,),
            "detail": (str,),
            "title": (str,),
        }

    attribute_map = {
        "code": "code",
        "detail": "detail",
        "title": "title",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """LogsWarning - a model defined in OpenAPI

        Keyword Args:
            code (str): [optional] A unique code for this type of warning
            detail (str): [optional] A detailed explanation of this specific warning
            title (str): [optional] A short human-readable summary of the warning
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(LogsWarning, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
