# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


class MetricIngestedIndexedVolumeAttributes(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "indexed_volume": (int,),
            "ingested_volume": (int,),
        }

    attribute_map = {
        "indexed_volume": "indexed_volume",
        "ingested_volume": "ingested_volume",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """MetricIngestedIndexedVolumeAttributes - a model defined in OpenAPI

        Keyword Args:
            indexed_volume (int): [optional] Indexed volume for the given metric.
            ingested_volume (int): [optional] Ingested volume for the given metric.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(MetricIngestedIndexedVolumeAttributes, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
