# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.metric_tag_configuration_type import MetricTagConfigurationType
    from datadog_api_client.v2.model.metric_tag_configuration_update_attributes import (
        MetricTagConfigurationUpdateAttributes,
    )

    globals()["MetricTagConfigurationType"] = MetricTagConfigurationType
    globals()["MetricTagConfigurationUpdateAttributes"] = MetricTagConfigurationUpdateAttributes


class MetricTagConfigurationUpdateData(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "attributes": (MetricTagConfigurationUpdateAttributes,),
            "id": (str,),
            "type": (MetricTagConfigurationType,),
        }

    attribute_map = {
        "id": "id",
        "type": "type",
        "attributes": "attributes",
    }

    read_only_vars = {}

    def __init__(self, id, type, *args, **kwargs):
        """MetricTagConfigurationUpdateData - a model defined in OpenAPI

        Args:
            id (str): The metric name for this resource.
            type (MetricTagConfigurationType):

        Keyword Args:
            attributes (MetricTagConfigurationUpdateAttributes): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.id = id
        self.type = type

    @classmethod
    def _from_openapi_data(cls, id, type, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(MetricTagConfigurationUpdateData, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.id = id
        self.type = type
        return self
