# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
    datetime,
)


class OrganizationAttributes(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "created_at": (datetime,),
            "description": (str,),
            "disabled": (bool,),
            "modified_at": (datetime,),
            "name": (str,),
            "public_id": (str,),
            "sharing": (str,),
            "url": (str,),
        }

    attribute_map = {
        "created_at": "created_at",
        "description": "description",
        "disabled": "disabled",
        "modified_at": "modified_at",
        "name": "name",
        "public_id": "public_id",
        "sharing": "sharing",
        "url": "url",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """OrganizationAttributes - a model defined in OpenAPI

        Keyword Args:
            created_at (datetime): [optional] Creation time of the organization.
            description (str): [optional] Description of the organization.
            disabled (bool): [optional] Whether or not the organization is disabled.
            modified_at (datetime): [optional] Time of last organization modification.
            name (str): [optional] Name of the organization.
            public_id (str): [optional] Public ID of the organization.
            sharing (str): [optional] Sharing type of the organization.
            url (str): [optional] URL of the site that this organization exists at.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(OrganizationAttributes, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
