# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


class PartialAPIKeyAttributes(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {
        "last4": {
            "max_length": 4,
            "min_length": 4,
        },
    }

    @cached_property
    def openapi_types():
        return {
            "created_at": (str,),
            "last4": (str,),
            "modified_at": (str,),
            "name": (str,),
        }

    attribute_map = {
        "created_at": "created_at",
        "last4": "last4",
        "modified_at": "modified_at",
        "name": "name",
    }

    read_only_vars = {
        "created_at",
        "last4",
        "modified_at",
    }

    def __init__(self, *args, **kwargs):
        """PartialAPIKeyAttributes - a model defined in OpenAPI

        Keyword Args:
            created_at (str): [optional] Creation date of the API key.
            last4 (str): [optional] The last four characters of the API key.
            modified_at (str): [optional] Date the API key was last modified.
            name (str): [optional] Name of the API key.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(PartialAPIKeyAttributes, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
