# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
    none_type,
)


class PartialApplicationKeyAttributes(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {
        "last4": {
            "max_length": 4,
            "min_length": 4,
        },
    }

    @cached_property
    def openapi_types():
        return {
            "created_at": (str,),
            "last4": (str,),
            "name": (str,),
            "scopes": (
                [str],
                none_type,
            ),
        }

    attribute_map = {
        "created_at": "created_at",
        "last4": "last4",
        "name": "name",
        "scopes": "scopes",
    }

    read_only_vars = {
        "created_at",
        "last4",
    }

    def __init__(self, *args, **kwargs):
        """PartialApplicationKeyAttributes - a model defined in OpenAPI

        Keyword Args:
            created_at (str): [optional] Creation date of the application key.
            last4 (str): [optional] The last four characters of the application key.
            name (str): [optional] Name of the application key.
            scopes ([str], none_type): [optional] Array of scopes to grant the application key. This feature is in private beta, please contact Datadog support to enable scopes for your application keys.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(PartialApplicationKeyAttributes, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
