# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


class ProcessSummariesMetaPage(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {
        "size": {
            "inclusive_maximum": 10000,
            "inclusive_minimum": 0,
        },
    }

    @cached_property
    def openapi_types():
        return {
            "after": (str,),
            "size": (int,),
        }

    attribute_map = {
        "after": "after",
        "size": "size",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """ProcessSummariesMetaPage - a model defined in OpenAPI

        Keyword Args:
            after (str): [optional] The cursor used to get the next results, if any. To make the next request, use the same parameters with the addition of the `page[cursor]`.
            size (int): [optional] Number of results returned.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(ProcessSummariesMetaPage, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
