# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.process_summaries_meta import ProcessSummariesMeta
    from datadog_api_client.v2.model.process_summary import ProcessSummary

    globals()["ProcessSummariesMeta"] = ProcessSummariesMeta
    globals()["ProcessSummary"] = ProcessSummary


class ProcessSummariesResponse(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "data": ([ProcessSummary],),
            "meta": (ProcessSummariesMeta,),
        }

    attribute_map = {
        "data": "data",
        "meta": "meta",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """ProcessSummariesResponse - a model defined in OpenAPI

        Keyword Args:
            data ([ProcessSummary]): [optional] Array of process summary objects.
            meta (ProcessSummariesMeta): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(ProcessSummariesResponse, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
