# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


class ProcessSummaryAttributes(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "cmdline": (str,),
            "host": (str,),
            "pid": (int,),
            "ppid": (int,),
            "start": (str,),
            "tags": ([str],),
            "timestamp": (str,),
            "user": (str,),
        }

    attribute_map = {
        "cmdline": "cmdline",
        "host": "host",
        "pid": "pid",
        "ppid": "ppid",
        "start": "start",
        "tags": "tags",
        "timestamp": "timestamp",
        "user": "user",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """ProcessSummaryAttributes - a model defined in OpenAPI

        Keyword Args:
            cmdline (str): [optional] Process command line.
            host (str): [optional] Host running the process.
            pid (int): [optional] Process ID.
            ppid (int): [optional] Parent process ID.
            start (str): [optional] Time the process was started.
            tags ([str]): [optional] List of tags associated with the process.
            timestamp (str): [optional] Time the process was seen.
            user (str): [optional] Process owner.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(ProcessSummaryAttributes, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
