# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
    datetime,
)


class RoleCreateAttributes(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "created_at": (datetime,),
            "modified_at": (datetime,),
            "name": (str,),
        }

    attribute_map = {
        "name": "name",
        "created_at": "created_at",
        "modified_at": "modified_at",
    }

    read_only_vars = {
        "created_at",
        "modified_at",
    }

    def __init__(self, name, *args, **kwargs):
        """RoleCreateAttributes - a model defined in OpenAPI

        Args:
            name (str): Name of the role.

        Keyword Args:
            created_at (datetime): [optional] Creation time of the role.
            modified_at (datetime): [optional] Time of last role modification.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.name = name

    @classmethod
    def _from_openapi_data(cls, name, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(RoleCreateAttributes, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.name = name
        return self
