# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.role_response_relationships import RoleResponseRelationships
    from datadog_api_client.v2.model.role_update_attributes import RoleUpdateAttributes
    from datadog_api_client.v2.model.roles_type import RolesType

    globals()["RoleResponseRelationships"] = RoleResponseRelationships
    globals()["RoleUpdateAttributes"] = RoleUpdateAttributes
    globals()["RolesType"] = RolesType


class RoleUpdateResponseData(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "attributes": (RoleUpdateAttributes,),
            "id": (str,),
            "relationships": (RoleResponseRelationships,),
            "type": (RolesType,),
        }

    attribute_map = {
        "type": "type",
        "attributes": "attributes",
        "id": "id",
        "relationships": "relationships",
    }

    read_only_vars = {}

    def __init__(self, type, *args, **kwargs):
        """RoleUpdateResponseData - a model defined in OpenAPI

        Args:
            type (RolesType):

        Keyword Args:
            attributes (RoleUpdateAttributes): [optional]
            id (str): [optional] ID of the role.
            relationships (RoleResponseRelationships): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.type = type

    @classmethod
    def _from_openapi_data(cls, type, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(RoleUpdateResponseData, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.type = type
        return self
