# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.security_monitoring_rule_severity import SecurityMonitoringRuleSeverity

    globals()["SecurityMonitoringRuleSeverity"] = SecurityMonitoringRuleSeverity


class SecurityMonitoringRuleCaseCreate(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "condition": (str,),
            "name": (str,),
            "notifications": ([str],),
            "status": (SecurityMonitoringRuleSeverity,),
        }

    attribute_map = {
        "status": "status",
        "condition": "condition",
        "name": "name",
        "notifications": "notifications",
    }

    read_only_vars = {}

    def __init__(self, status, *args, **kwargs):
        """SecurityMonitoringRuleCaseCreate - a model defined in OpenAPI

        Args:
            status (SecurityMonitoringRuleSeverity):

        Keyword Args:
            condition (str): [optional] A rule case contains logical operations (`>`,`>=`, `&&`, `||`) to determine if a signal should be generated based on the event counts in the previously defined queries.
            name (str): [optional] Name of the case.
            notifications ([str]): [optional] Notification targets for each rule case.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

        self.status = status

    @classmethod
    def _from_openapi_data(cls, status, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SecurityMonitoringRuleCaseCreate, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        self.status = status
        return self
