# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.security_monitoring_rule_detection_method import (
        SecurityMonitoringRuleDetectionMethod,
    )
    from datadog_api_client.v2.model.security_monitoring_rule_evaluation_window import (
        SecurityMonitoringRuleEvaluationWindow,
    )
    from datadog_api_client.v2.model.security_monitoring_rule_keep_alive import SecurityMonitoringRuleKeepAlive
    from datadog_api_client.v2.model.security_monitoring_rule_max_signal_duration import (
        SecurityMonitoringRuleMaxSignalDuration,
    )
    from datadog_api_client.v2.model.security_monitoring_rule_new_value_options import (
        SecurityMonitoringRuleNewValueOptions,
    )

    globals()["SecurityMonitoringRuleDetectionMethod"] = SecurityMonitoringRuleDetectionMethod
    globals()["SecurityMonitoringRuleEvaluationWindow"] = SecurityMonitoringRuleEvaluationWindow
    globals()["SecurityMonitoringRuleKeepAlive"] = SecurityMonitoringRuleKeepAlive
    globals()["SecurityMonitoringRuleMaxSignalDuration"] = SecurityMonitoringRuleMaxSignalDuration
    globals()["SecurityMonitoringRuleNewValueOptions"] = SecurityMonitoringRuleNewValueOptions


class SecurityMonitoringRuleOptions(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "detection_method": (SecurityMonitoringRuleDetectionMethod,),
            "evaluation_window": (SecurityMonitoringRuleEvaluationWindow,),
            "keep_alive": (SecurityMonitoringRuleKeepAlive,),
            "max_signal_duration": (SecurityMonitoringRuleMaxSignalDuration,),
            "new_value_options": (SecurityMonitoringRuleNewValueOptions,),
        }

    attribute_map = {
        "detection_method": "detectionMethod",
        "evaluation_window": "evaluationWindow",
        "keep_alive": "keepAlive",
        "max_signal_duration": "maxSignalDuration",
        "new_value_options": "newValueOptions",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """SecurityMonitoringRuleOptions - a model defined in OpenAPI

        Keyword Args:
            detection_method (SecurityMonitoringRuleDetectionMethod): [optional]
            evaluation_window (SecurityMonitoringRuleEvaluationWindow): [optional]
            keep_alive (SecurityMonitoringRuleKeepAlive): [optional]
            max_signal_duration (SecurityMonitoringRuleMaxSignalDuration): [optional]
            new_value_options (SecurityMonitoringRuleNewValueOptions): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SecurityMonitoringRuleOptions, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
