# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.security_monitoring_filter import SecurityMonitoringFilter
    from datadog_api_client.v2.model.security_monitoring_rule_case import SecurityMonitoringRuleCase
    from datadog_api_client.v2.model.security_monitoring_rule_options import SecurityMonitoringRuleOptions
    from datadog_api_client.v2.model.security_monitoring_rule_query import SecurityMonitoringRuleQuery
    from datadog_api_client.v2.model.security_monitoring_rule_type_read import SecurityMonitoringRuleTypeRead

    globals()["SecurityMonitoringFilter"] = SecurityMonitoringFilter
    globals()["SecurityMonitoringRuleCase"] = SecurityMonitoringRuleCase
    globals()["SecurityMonitoringRuleOptions"] = SecurityMonitoringRuleOptions
    globals()["SecurityMonitoringRuleQuery"] = SecurityMonitoringRuleQuery
    globals()["SecurityMonitoringRuleTypeRead"] = SecurityMonitoringRuleTypeRead


class SecurityMonitoringRuleResponse(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "cases": ([SecurityMonitoringRuleCase],),
            "created_at": (int,),
            "creation_author_id": (int,),
            "filters": ([SecurityMonitoringFilter],),
            "has_extended_title": (bool,),
            "id": (str,),
            "is_default": (bool,),
            "is_deleted": (bool,),
            "is_enabled": (bool,),
            "message": (str,),
            "name": (str,),
            "options": (SecurityMonitoringRuleOptions,),
            "queries": ([SecurityMonitoringRuleQuery],),
            "tags": ([str],),
            "type": (SecurityMonitoringRuleTypeRead,),
            "update_author_id": (int,),
            "version": (int,),
        }

    attribute_map = {
        "cases": "cases",
        "created_at": "createdAt",
        "creation_author_id": "creationAuthorId",
        "filters": "filters",
        "has_extended_title": "hasExtendedTitle",
        "id": "id",
        "is_default": "isDefault",
        "is_deleted": "isDeleted",
        "is_enabled": "isEnabled",
        "message": "message",
        "name": "name",
        "options": "options",
        "queries": "queries",
        "tags": "tags",
        "type": "type",
        "update_author_id": "updateAuthorId",
        "version": "version",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """SecurityMonitoringRuleResponse - a model defined in OpenAPI

        Keyword Args:
            cases ([SecurityMonitoringRuleCase]): [optional] Cases for generating signals.
            created_at (int): [optional] When the rule was created, timestamp in milliseconds.
            creation_author_id (int): [optional] User ID of the user who created the rule.
            filters ([SecurityMonitoringFilter]): [optional] Additional queries to filter matched events before they are processed.
            has_extended_title (bool): [optional] Whether the notifications include the triggering group-by values in their title.
            id (str): [optional] The ID of the rule.
            is_default (bool): [optional] Whether the rule is included by default.
            is_deleted (bool): [optional] Whether the rule has been deleted.
            is_enabled (bool): [optional] Whether the rule is enabled.
            message (str): [optional] Message for generated signals.
            name (str): [optional] The name of the rule.
            options (SecurityMonitoringRuleOptions): [optional]
            queries ([SecurityMonitoringRuleQuery]): [optional] Queries for selecting logs which are part of the rule.
            tags ([str]): [optional] Tags for generated signals.
            type (SecurityMonitoringRuleTypeRead): [optional]
            update_author_id (int): [optional] User ID of the user who updated the rule.
            version (int): [optional] The version of the rule.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SecurityMonitoringRuleResponse, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
