# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


def lazy_import():
    from datadog_api_client.v2.model.security_monitoring_signal_attributes import SecurityMonitoringSignalAttributes
    from datadog_api_client.v2.model.security_monitoring_signal_type import SecurityMonitoringSignalType

    globals()["SecurityMonitoringSignalAttributes"] = SecurityMonitoringSignalAttributes
    globals()["SecurityMonitoringSignalType"] = SecurityMonitoringSignalType


class SecurityMonitoringSignal(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        lazy_import()
        return {
            "attributes": (SecurityMonitoringSignalAttributes,),
            "id": (str,),
            "type": (SecurityMonitoringSignalType,),
        }

    attribute_map = {
        "attributes": "attributes",
        "id": "id",
        "type": "type",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """SecurityMonitoringSignal - a model defined in OpenAPI

        Keyword Args:
            attributes (SecurityMonitoringSignalAttributes): [optional]
            id (str): [optional] The unique ID of the security signal.
            type (SecurityMonitoringSignalType): [optional]
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SecurityMonitoringSignal, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
