# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
    date,
    datetime,
    none_type,
)


class SecurityMonitoringSignalAttributes(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "attributes": ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),
            "message": (str,),
            "tags": ([str],),
            "timestamp": (datetime,),
        }

    attribute_map = {
        "attributes": "attributes",
        "message": "message",
        "tags": "tags",
        "timestamp": "timestamp",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """SecurityMonitoringSignalAttributes - a model defined in OpenAPI

        Keyword Args:
            attributes ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional] A JSON object of attributes in the security signal.
            message (str): [optional] The message in the security signal defined by the rule that generated the signal.
            tags ([str]): [optional] An array of tags associated with the security signal.
            timestamp (datetime): [optional] The timestamp of the security signal.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(SecurityMonitoringSignalAttributes, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
