# Unless explicitly stated otherwise all files in this repository are licensed under the Apache-2.0 License.
# This product includes software developed at Datadog (https://www.datadoghq.com/).
# Copyright 2019-Present Datadog, Inc.


from datadog_api_client.v2.model_utils import (
    ModelNormal,
    cached_property,
)


class UserUpdateAttributes(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    validations = {}

    @cached_property
    def openapi_types():
        return {
            "disabled": (bool,),
            "email": (str,),
            "name": (str,),
        }

    attribute_map = {
        "disabled": "disabled",
        "email": "email",
        "name": "name",
    }

    read_only_vars = {}

    def __init__(self, *args, **kwargs):
        """UserUpdateAttributes - a model defined in OpenAPI

        Keyword Args:
            disabled (bool): [optional] If the user is enabled or disabled.
            email (str): [optional] The email of the user.
            name (str): [optional] The name of the user.
        """
        super().__init__(kwargs)

        self._check_pos_args(args)

    @classmethod
    def _from_openapi_data(cls, *args, **kwargs):
        """Helper creating a new instance from a response."""

        self = super(UserUpdateAttributes, cls)._from_openapi_data(kwargs)

        self._check_pos_args(args)

        return self
